const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const shipping_carriers = sequelize.define(
    'shipping_carriers',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

tracking_url_template: {
        type: DataTypes.TEXT,
      
      

      },

support_phone: {
        type: DataTypes.TEXT,
      
      

      },

is_active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  shipping_carriers.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity






















    db.shipping_carriers.hasMany(db.shipments, {
      as: 'shipments_carrier',
      foreignKey: {
          name: 'carrierId',
      },
      constraints: false,
    });























//end loop






    db.shipping_carriers.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.shipping_carriers.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return shipping_carriers;
};


